/* DEFNIES: CANBUS  WITS STYLE */

//int true = 1;
//int false = 0;

struct WITS_CONFIG {
		/* index / categories */
		int num_cats;
		int cat_pwr_ctrl;   // index0 - computer power controls
		int cat_measurements; // index1 - measurements
		int cat_manual_input_state; // index2 - manual input states
		int cat_autowarning;  // index3 -- automatic input states
	        int cat_ambient_params; // index4 - ambient parameters
	        int cat_TBD;  // index5 - to be determined

		/* pos */
		  /* index 0   computer power controls */
		   int num_idx0;
	       int pwr_relay0;
	       int pwr_relay1;
	       int index0[2];
	       int index0_modif[2];
		const char *m0[2];

	      /* index 1   measurements*/
	       int num_idx1;
	       int gas_level;
	       int core_temp;
	       int bat_voltage;
	       int engine_core_press;
	       int speed_kmh;
	       int rpm;
	       int rads;
	       int battchg;
	       int gas_lpm;
	       int gas_inst;
	       int index1[0x0A];
	       int index1_modif[0x0A];
		const char *m1[0x0A];

	      /* index 2    manual input states / user input states / user interraction states */
	       int num_idx2;
	       int poz_lights;
	       int short_lights;
	       int long_lights;
	       int rear_fog_lights;
	       int front_fog_lights; // projectors
	       int dir_signal_left ;
	       int dir_signal_right;
	       int foot_brake;
	       int manual_brake;
	       int belt_driver;
	       int seat_driver;
	       int belt_left;
	       int seat_left;
	       int belt_3;
	       int seat_3;
	       int belt_4;
	       int seat_4;   
	       int belt_5;
	       int seat_5;
	       int front_left_door;
	       int front_right_door;
	       int rear_left_door;
	       int rear_right_door;
	       int trunk;
	       int marche_a_rierre;
	       int index2[0x17];
	       int index2_modif[0x17];
		const char *m2[0x17];
	      
	      /* index 3   automatic input states */
	       int num_idx3;
	       int low_fuel_alarm;
	       int overheat_alarm;
	       int low_press_alarm;
	       int vent_engine_alarm;
	       int neural_net_alarm;
	       int index3[5];
	       int index3_modif[5];
		const char *m3[0x05];
	      
	     /* index 4   ambient parameters */
	       int num_idx4;
	       int ambient_light;
	       int power_state;
	       int bk_gas_gauge;
	       int pointer_gas_gauge;
	       int bk_press_gauge;
	       int pointer_press_gauge;
	       int bk_batt_gauge;
	       int pointer_batt_gauge;
	       int bk_coretemp;
	       int pointer_coretemp;
	       int bk_speed_0;   
	       int bk_speed_1; 
	       int bk_speed_2;  
	       int bk_speed_3;
	       int bk_speed_4;  
	       int pointer_speed_gauge;
	       int bk_rpm_0;
	       int bk_rpm_1;
	       int bk_rpm_2;
	       int bk_rpm_3;
	       int bk_rpm_4;
	       int pointer_rpm_gauge;
	       int pointer_rad_gauge; 
	       int pointer_chg_gauge;   
	       int index4[0x17];
	       int index4_modif[0x17];
		const char *m4[0x17];

  
} sysctl;
// END DEFINES: CANBUS
//#########################################################################################

void witsinit() {

	        int i=0;
	      /* index / categories */
	      sysctl.num_cats = 0x05;
	      sysctl.cat_pwr_ctrl = 0x00;   // index0 - computer power controls
	      sysctl.cat_measurements = 0x01; // index1 - measurements
	      sysctl.cat_manual_input_state = 0x02; // index2 - manual input states
	      sysctl.cat_autowarning = 0x03;  // index3 -- automatic input states
	      sysctl.cat_ambient_params = 0x04; // index4 - ambient parameters
	      sysctl.cat_TBD = 0x05;  // index5 - to be determined
	      
	      /* pos */
	      /* index 0   computer power controls */
	      sysctl.num_idx0 = 0x02;   
	      sysctl.pwr_relay0 = 0x00; 
	      sysctl.pwr_relay1 = 0x01;

	      for (i=0; i<0x02; i++) {
		    			sysctl.index0[i] = 0x00;
		    			sysctl.index0_modif[i] = 0x00;
	      }

	      sysctl.m0[0] = "RL0\0" ;
	      sysctl.m0[1] = "RL1\0";
	      
	     
	      /* index 1   measurements*/
	      sysctl.num_idx1 = 0x0A; 
	      sysctl.gas_level = 0x00;
	      sysctl.core_temp = 0x01;
	      sysctl.bat_voltage = 0x02; 
	      sysctl.engine_core_press = 0x03;
	      sysctl.speed_kmh = 0x04;  
	      sysctl.rpm = 0x05;
	      sysctl.rads = 0x06;
	      sysctl.battchg = 0x07;
	      sysctl.gas_lpm = 0x08;
	      sysctl.gas_inst = 0x09;
	      for (i=0; i<0x0A; i++) {
		    			sysctl.index1[i] = 0x00;
		    			sysctl.index1_modif[i] = 0x00;
	      }
    
		sysctl.m1[0] = "GASLEVL\0";
		sysctl.m1[1] = "CORETMP\0";
		sysctl.m1[2] = "BATTLVL\0";
		sysctl.m1[3] = "OILPRES\0";
		sysctl.m1[4] = "SPEEDKM\0";
		sysctl.m1[5] = "SHFTRPM\0";
		sysctl.m1[6] = "RADREMS\0";
		sysctl.m1[7] = "BATTCHG\0";
		sysctl.m1[8] = "GASSLPM\0";
		sysctl.m1[9] = "GASSLPS\0";
		



	      /* index 2    manual input states / user input states / user interraction states */
	      sysctl.num_idx2 = 0x17;
	      sysctl.poz_lights = 0x00;
	      sysctl.short_lights = 0x01;
	      sysctl.long_lights = 0x02;
	      sysctl.rear_fog_lights = 0x03;
	      sysctl.front_fog_lights = 0x04; // projectors
	      sysctl.dir_signal_left = 0x05;
	      sysctl.dir_signal_right = 0x05;
	      sysctl.foot_brake = 0x06;
	      sysctl.manual_brake = 0x07;
	      sysctl.belt_driver = 0x08;
	      sysctl.seat_driver = 0x09;
	      sysctl.belt_left = 0x0A;
	      sysctl.seat_left = 0x0B;
	      sysctl.belt_3 = 0x0C;
	      sysctl.seat_3 = 0x0D;
	      sysctl.belt_4 = 0x0E;
	      sysctl.seat_4 = 0x0F;   
	      sysctl.belt_5 = 0x10;
	      sysctl.seat_5 = 0x11;
	      sysctl.front_left_door = 0x12;
	      sysctl.front_right_door = 0x13;
	      sysctl.rear_left_door = 0x14;
	      sysctl.rear_right_door = 0x15;
	      sysctl.trunk = 0x16;
	      sysctl.marche_a_rierre = 0x17;
	      for (i=0; i<0x17; i++) {
	        			    sysctl.index2[i]=0x00;
		    			    sysctl.index2_modif[i] = 0x00;
    	     }
	
	     // mnemonics
	     sysctl.m2[0x00] = "POSLGHT\0"; // position lights
	     sysctl.m2[0x01] = "SHRLGHT\0"; // short lights
	     sysctl.m2[0x02] = "LNGLHGT\0"; // long lights
	     sysctl.m2[0x03] = "RFGLGHT\0"; // rear fog lights
	     sysctl.m2[0x04] = "FFGLGHT\0"; // front fog lights
	     sysctl.m2[0x05] = "DSGLLFT\0"; // dir signal left
	    // sysctl.m2[0x05] = "DSGLRHT\0";  // dir signal right
	     sysctl.m2[0x06] = "FOOTBRK\0"; // 
	     sysctl.m2[0x07] = "MANUBRK\0";
	     sysctl.m2[0x08] = "BELTDRV\0";
	     sysctl.m2[0x09] = "SEATDRV\0";
	     sysctl.m2[0x0A] = "BELTLFT\0";
	     sysctl.m2[0x0B] = "SEATLFT\0";
	     sysctl.m2[0x0C] = "BELT003\0";
	     sysctl.m2[0x0D] = "SEAT003\0";
	     sysctl.m2[0x0E] = "BELT004\0";
	     sysctl.m2[0x0F] = "SEAT004\0";
	     sysctl.m2[0x10] = "BELT005\0";
	     sysctl.m2[0x11] = "SEAT005\0";
	     sysctl.m2[0x12] = "FRLFTDR\0"; // front left door
	     sysctl.m2[0x13] = "FRRHTDR\0"; // front right door
	     sysctl.m2[0x14] = "RELFTDR\0"; // rear left door
	     sysctl.m2[0x15] = "RERHTDR\0"; // rear right door
	     sysctl.m2[0x16] = "TRUNK__\0"; // trunk sensor
	     sysctl.m2[0x17] = "GOBACK_\0"; // backwards gear box sensor


	     /* index 3   automatic input states */
	      sysctl.num_idx3 = 0x04;
	      sysctl.low_fuel_alarm = 0x00;
	      sysctl.overheat_alarm = 0x01;
	      sysctl.low_press_alarm = 0x02;
	      sysctl.vent_engine_alarm = 0x03;
	      sysctl.neural_net_alarm = 0x04;
	      
	      for (i=0; i<0x05; i++) {
	        			sysctl.index3[i]=0x00;
		    			sysctl.index3_modif[i] = 0x00;
	     }
	     sysctl.m3[0x00] = "LOWFUEL\0"; // low fuel alarm
	     sysctl.m3[0x01] = "OVRHEAT\0"; // overheat alarm
	     sysctl.m3[0x02] = "LOWPRES\0"; // low core oil pressure
	     sysctl.m3[0x03] = "VENTSNZ\0"; // vent engine sensor
	     sysctl.m3[0x04] = "AINTWRK\0"; // artifficial neural network alarm



	      /* index 4   ambient parameters */
	      sysctl.num_idx4 = 0x17;
	      sysctl.ambient_light = 0x00;
	      sysctl.power_state = 0x01;
	      sysctl.bk_gas_gauge = 0x02;
	      sysctl.pointer_gas_gauge = 0x03;
	      sysctl.bk_press_gauge = 0x04;
	      sysctl.pointer_press_gauge = 0x05;
	      sysctl.bk_batt_gauge = 0x06;
	      sysctl.pointer_batt_gauge = 0x07;
	      sysctl.bk_coretemp = 0x08;
	      sysctl.pointer_coretemp = 0x09;
	      sysctl.bk_speed_0 = 0x0A;   
	      sysctl.bk_speed_1 = 0x0B; 
	      sysctl.bk_speed_2 = 0x0C;  
	      sysctl.bk_speed_3 = 0x0D;
	      sysctl.bk_speed_4 = 0x0E;  
	      sysctl.pointer_speed_gauge = 0x0F;
	      sysctl.bk_rpm_0 = 0x10;
	      sysctl.bk_rpm_1 = 0x11;
	      sysctl.bk_rpm_2 = 0x12;
	      sysctl.bk_rpm_3 = 0x13;
	      sysctl.bk_rpm_4 = 0x14;
	      sysctl.pointer_rpm_gauge = 0x15;
	      sysctl.pointer_rad_gauge = 0x16; 
	      sysctl.pointer_chg_gauge = 0x17;   
	      for (i=0; i<0x17; i++) {
		    			sysctl.index4[i]=0x00;
		    			sysctl.index4_modif[i] = 0x00;
	      }
	
	    // mnemonics
	     sysctl.m4[0x00] = "AMBLGHT\0"; // ambient light sensor
	     sysctl.m4[0x01] = "PWRSTAT\0"; // power state
	     sysctl.m4[0x02] = "BKGASGG\0"; // backlight gas gauge
	     sysctl.m4[0x03] = "PTGASGG\0"; // pointer gas gauge
	     sysctl.m4[0x04] = "BKPRSGG\0"; // backlight press gauge
	     sysctl.m4[0x05] = "PTPRSGG\0"; // pointer press gauge
	     sysctl.m4[0x06] = "BKBATGG\0"; // backlight battery gauge
	     sysctl.m4[0x07] = "PTBATGG\0"; // pointer batt gauge
	     sysctl.m4[0x08] = "BKCORET\0"; // backlight core temp gauge
	     sysctl.m4[0x09] = "PTCORET\0"; // pointer core temp gauge
	     sysctl.m4[0x0A] = "BKSPGG0\0"; // backlight 0 speed gauge
	     sysctl.m4[0x0B] = "BKSPGG1\0"; // backlight 1 speed gauge
	     sysctl.m4[0x0C] = "BKSPGG2\0"; // backlight 2 speed gauge
	     sysctl.m4[0x0D] = "BKSPGG3\0"; // backlight 3 speed gauge
	     sysctl.m4[0x0E] = "BKSPGG4\0"; // backlight 4 speed gauge
	     sysctl.m4[0x0F] = "PTSPDGG\0"; // pointer speed gauge
	     sysctl.m4[0x10] = "BKRPMG0\0"; // backlight 0 RPM gauge
	     sysctl.m4[0x11] = "BKRPMG1\0"; // backlight 1 RPM
	     sysctl.m4[0x12] = "BKRPMG2\0"; // backlight 2 RPM
	     sysctl.m4[0x13] = "BKRPMG3\0"; // backlight 3 RPM
	     sysctl.m4[0x14] = "BKRPMG4\0"; // backlight 4 RPM
	     sysctl.m4[0x15] = "PTRPMGG\0"; // pointer RPM gauge
	     sysctl.m4[0x16] = "PTRADGG\0"; // pointer radiagion gauge
	     sysctl.m4[0x17] = "PTCHGGG\0"; // pointer charger gauge

	    
}
